
#ifndef HASH_H
#define HASH_H

#include <stdio.h>
#include <stdlib.h>
#include "sequence.h"

struct lowerHash_s
{
	int noOfSlot;

	sequenceSet **slot;
};

typedef struct lowerHash_s lowerHash;

struct upperHash_s
{
	int noOfSlot;

	int noOfEntry;

	lowerHash **slot;
};

typedef struct upperHash_s upperHash;

void lowerHash_insert(lowerHash *aLowerHash, sequence *aSequence);
void upperHash_insert(upperHash *aUpperHash, sequence *aSequence);

upperHash *upperHash_new(int upper_noOfSlot, int lower_noOfSlot);
int lowerHash_isExist(lowerHash *aLowerHash, sequence *aSequence);

int upperHash_isEmpty(upperHash *aUpperHash);
void upperHash_free(upperHash *aUpperHash);

upperHash *upperHash_clone(upperHash *aUpperHash);
void upperHash_removeService(upperHash *aUpperHash, int fromNo, int toNo);
void upperHash_print(upperHash *aUpperHash);
int upperHash_isExist(upperHash *aUpperHash, sequence *aSequence);
#endif

