
#ifndef SERIVCE_H
#define SERVICE_H

#include "set.h"
#include "sequence.h"
#include "hash.h"
#include "config.h"
#include "readGen.h"

#define DRILLDOWN 0
#define ROLLUP 1
#define PREPEND 2
#define APPEND 3
#define DETAIL 4
#define DEHEAD 5

void service_extractAllPotentialCompetitiveSerivceFromData(data *aData, upperHash *aUpperHash, mySetSet *closeSetSet, int *ownerTable);
sequence *generateRandomSequence(int seqLen, generalizedDimTable *genHierarchy);
upperHash *service_findAllCompetitiveService(config *aConfig, upperHash *aUpperHash, mySetSet *closeSetSet, int *ownerTable);
mySetSet *findAllCompetitionAware(config *aConfig, generalizedDimTable *genHierarchy, mySetSet *aCloseSetSet);
mySetSet **generateReverseGForAllNode(generalizedDimTable *genHierarchy, int noOfValue);
upperHash *generatePCSSFromSummary(sequence *aSequence, config *aConfig, mySetSet **allGroundSet, upperHash *competitiveServiceSet, mySetSet *allCompetitionAwareNode);
//int determineWhetherQueryCompetitiveFreeFromPCSS(config *aConfig, upperHash *PCSS, mySetSet *closeSetSet, int *ownerTable);
int determineWhetherQueryCompetitionFree(int prev_isCompetitive, int olap_operation, generalizedDimTable *genHierarchy, config *aConfig, sequence **newSequence, upperHash **newPCSS, sequence *prevSequence, upperHash *prevPCSS, mySetSet *allCompetitionAwareNode, mySetSet **allGroundSet, upperHash *competitiveServiceSet, mySetSet *closeSetSet, int *ownerTable);
void printAllGroundSet(mySetSet **allGroundSet, int noOfLevel);
int determineWhetherQueryCompetitiveFreeFromPCSS(config *aConfig, upperHash *competitiveHash, upperHash *PCSS, mySetSet *closeSetSet, int *ownerTable);

#endif
