
#ifndef SET_H
#define SET_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct mySet_s
{
	int noOfElt;
	int *elt;
};

typedef struct mySet_s mySet;

struct mySetSet_s
{
	int noOfElt;
	mySet **elt;
};

typedef struct mySetSet_s mySetSet;

mySet *mySet_new();
void mySet_insert(mySet *aSet, int eltNo);
mySet *mySet_new_noOfElt(int noOfElt);
mySetSet *mySetSet_new_noOfElt(int noOfElt);
int mySet_isExist(mySet *aSet, int no);
void mySet_insert_nonRedundance(mySet *aSet, int eltNo);
void mySetSet_free(mySetSet *aSetSet);
void mySet_free(mySet *aSet);
mySet *mySet_minus(mySet *set1, mySet *set2);
void mySet_print(mySet *aSet);
void mySetSet_print(mySetSet *aSetSet);

#endif
