
#ifndef STAT_H
#define STAT_H

#include <stdio.h>
#include <stdlib.h>
#include "hash.h"
#include "set.h"

struct statistics_s
{
	int noOfRestrictedQueries;
	int totalNoOfQueries;
	double percentOfRestrictedQueries;

	double totalSize_PCSS;
	double avgSize_PCSS;

	int size_competitiveService;

	int totalQueryLength;
	double avgQueryLength;
};

typedef struct statistics_s statistics;

void stat_print(FILE *filePtr, statistics *aStat);
statistics *stat_new();
int stat_calculateUpperHashSize(upperHash *aUpperHash);

#endif
