
#ifndef SEQUENCE_H
#define SEQUENCE_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define COUNT 0
#define MAX 1
#define MIN 2
#define AVG 3

struct sequence_s
{
	int noOfElt;

	int *elt;
	int *level;

	int isCompetitive;
};

typedef struct sequence_s sequence;


struct sequenceSet_s
{
	int noOfElt;

	sequence **elt;
};

typedef struct sequenceSet_s sequenceSet;


struct query_s
{
	sequence *content;
	int aggregateFunction;
};

typedef struct query_s query;

//sequence *sequence_new(int noOfElt);
sequenceSet *sequenceSet_new();
int sequenceSet_isExist(sequenceSet *aSequenceSet, sequence *aSequence);
void sequenceSet_insert(sequenceSet *aSequenceSet, sequence *aSequence);
sequence *sequence_new_noOfElt(int noOfElt);
void sequence_free(sequence *aSequence);
void sequenceSet_free(sequenceSet *aSequenceSet);
sequenceSet *sequenceSet_clone(sequenceSet *aSequenceSet);
void sequenceSet_remove(sequenceSet *aSequenceSet, sequence *aSequence);
sequence *sequence_new();
void sequenceSet_print(sequenceSet *aSeqSet);
sequence *sequence_clone(sequence *aSequence);
void sequence_print(sequence *aSequence);

#endif

